# coding: utf-8

"""
    Sunshine Conversations API

    The version of the OpenAPI document: 15.5.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


from sunshine_conversations_client.configuration import Configuration
from sunshine_conversations_client.undefined import Undefined


class User(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'authenticated': 'bool',
        'external_id': 'str',
        'zendesk_id': 'str',
        'signed_up_at': 'str',
        'to_be_retained': 'bool',
        'profile': 'Profile',
        'metadata': 'dict',
        'identities': 'list[Identity]'
    }

    attribute_map = {
        'id': 'id',
        'authenticated': 'authenticated',
        'external_id': 'externalId',
        'zendesk_id': 'zendeskId',
        'signed_up_at': 'signedUpAt',
        'to_be_retained': 'toBeRetained',
        'profile': 'profile',
        'metadata': 'metadata',
        'identities': 'identities'
    }

    nulls = set()

    def __init__(self, id=None, authenticated=None, external_id=Undefined(), zendesk_id=Undefined(), signed_up_at=None, to_be_retained=None, profile=None, metadata=None, identities=None, local_vars_configuration=None):  # noqa: E501
        """User - a model defined in OpenAPI"""  # noqa: E501
        
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._authenticated = None
        self._external_id = None
        self._zendesk_id = None
        self._signed_up_at = None
        self._to_be_retained = None
        self._profile = None
        self._metadata = None
        self._identities = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if authenticated is not None:
            self.authenticated = authenticated
        self.external_id = external_id
        self.zendesk_id = zendesk_id
        if signed_up_at is not None:
            self.signed_up_at = signed_up_at
        if to_be_retained is not None:
            self.to_be_retained = to_be_retained
        if profile is not None:
            self.profile = profile
        if metadata is not None:
            self.metadata = metadata
        if identities is not None:
            self.identities = identities

    @property
    def id(self):
        """Gets the id of this User.  # noqa: E501

        The unique ID of the user.  # noqa: E501

        :return: The id of this User.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this User.

        The unique ID of the user.  # noqa: E501

        :param id: The id of this User.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def authenticated(self):
        """Gets the authenticated of this User.  # noqa: E501

        Whether or not the user has authenticated, either via JWT or via the Help Center  # noqa: E501

        :return: The authenticated of this User.  # noqa: E501
        :rtype: bool
        """
        return self._authenticated

    @authenticated.setter
    def authenticated(self, authenticated):
        """Sets the authenticated of this User.

        Whether or not the user has authenticated, either via JWT or via the Help Center  # noqa: E501

        :param authenticated: The authenticated of this User.  # noqa: E501
        :type: bool
        """

        self._authenticated = authenticated

    @property
    def external_id(self):
        """Gets the external_id of this User.  # noqa: E501

        An optional ID that can also be used to retrieve the user.   # noqa: E501

        :return: The external_id of this User.  # noqa: E501
        :rtype: str
        """
        return self._external_id

    @external_id.setter
    def external_id(self, external_id):
        """Sets the external_id of this User.

        An optional ID that can also be used to retrieve the user.   # noqa: E501

        :param external_id: The external_id of this User.  # noqa: E501
        :type: str
        """
        if type(external_id) is Undefined:
            external_id = None
            self.nulls.discard("external_id")
        elif external_id is None:
            self.nulls.add("external_id")
        else:
            self.nulls.discard("external_id")

        self._external_id = external_id

    @property
    def zendesk_id(self):
        """Gets the zendesk_id of this User.  # noqa: E501

        The ID that links a messaging user to its core Zendesk user counterpart. This ID can be used to fetch the core user record via the Zendesk Support API.   # noqa: E501

        :return: The zendesk_id of this User.  # noqa: E501
        :rtype: str
        """
        return self._zendesk_id

    @zendesk_id.setter
    def zendesk_id(self, zendesk_id):
        """Sets the zendesk_id of this User.

        The ID that links a messaging user to its core Zendesk user counterpart. This ID can be used to fetch the core user record via the Zendesk Support API.   # noqa: E501

        :param zendesk_id: The zendesk_id of this User.  # noqa: E501
        :type: str
        """
        if type(zendesk_id) is Undefined:
            zendesk_id = None
            self.nulls.discard("zendesk_id")
        elif zendesk_id is None:
            self.nulls.add("zendesk_id")
        else:
            self.nulls.discard("zendesk_id")

        self._zendesk_id = zendesk_id

    @property
    def signed_up_at(self):
        """Gets the signed_up_at of this User.  # noqa: E501


        :return: The signed_up_at of this User.  # noqa: E501
        :rtype: str
        """
        return self._signed_up_at

    @signed_up_at.setter
    def signed_up_at(self, signed_up_at):
        """Sets the signed_up_at of this User.


        :param signed_up_at: The signed_up_at of this User.  # noqa: E501
        :type: str
        """

        self._signed_up_at = signed_up_at

    @property
    def to_be_retained(self):
        """Gets the to_be_retained of this User.  # noqa: E501


        :return: The to_be_retained of this User.  # noqa: E501
        :rtype: bool
        """
        return self._to_be_retained

    @to_be_retained.setter
    def to_be_retained(self, to_be_retained):
        """Sets the to_be_retained of this User.


        :param to_be_retained: The to_be_retained of this User.  # noqa: E501
        :type: bool
        """

        self._to_be_retained = to_be_retained

    @property
    def profile(self):
        """Gets the profile of this User.  # noqa: E501


        :return: The profile of this User.  # noqa: E501
        :rtype: Profile
        """
        return self._profile

    @profile.setter
    def profile(self, profile):
        """Sets the profile of this User.


        :param profile: The profile of this User.  # noqa: E501
        :type: Profile
        """

        self._profile = profile

    @property
    def metadata(self):
        """Gets the metadata of this User.  # noqa: E501


        :return: The metadata of this User.  # noqa: E501
        :rtype: dict
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this User.


        :param metadata: The metadata of this User.  # noqa: E501
        :type: dict
        """

        self._metadata = metadata

    @property
    def identities(self):
        """Gets the identities of this User.  # noqa: E501

        The user's connected identities.  # noqa: E501

        :return: The identities of this User.  # noqa: E501
        :rtype: list[Identity]
        """
        return self._identities

    @identities.setter
    def identities(self, identities):
        """Sets the identities of this User.

        The user's connected identities.  # noqa: E501

        :param identities: The identities of this User.  # noqa: E501
        :type: list[Identity]
        """

        self._identities = identities

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, User):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, User):
            return True

        return self.to_dict() != other.to_dict()
